/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package edu.uconn.ngstools.main;
import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintStream;
import edu.uconn.ngstools.readalignments.ReadAlignment;
import edu.uconn.ngstools.readalignments.filehandlers.SAMReadAlignmentsHandler;

/**
 *
 * @author Sahar
 */
public class FilterLocalAlignments {

private static PrintStream outputFileStream;
private static FileInputStream inputFile;
private static int mappableBasesThreshold = 15;
private static double clippingThreshold = 0.25;
private static int validAlignments = 0;


public static void main(String[] args) throws Exception {
		FilterLocalAlignments filter = new FilterLocalAlignments();
		SAMReadAlignmentsHandler alnsHandlerTranscriptome=new SAMReadAlignmentsHandler();
		alnsHandlerTranscriptome.setMultipleAlnsPerRead(true);
		int i=0;
//		while(i<args.length && args[i].charAt(0)=='-') {
//			if("-t".equalsIgnoreCase(args[i])) {
//				i++;
//				merger.mergeType = args[i];
//			}
//			i++;
//		}
		String inFile = args[i];
		i++;
		String outFile = args[i];
                inputFile = new FileInputStream(inFile);
                outputFileStream = new PrintStream(outFile);
                System.out.println("Reading Alignments in SAM File");
                filter.printHeader(inFile,outputFileStream);
                long inputAlignmentsCount = filter.filterAlignments(inputFile,outputFileStream);
    		//List<ReadAlignment> alns =
		System.out.println("Filtering process finished.");
//                System.out.println("Input number of alignments: "+inputAlignmentsCount);
//               System.out.println("Filtered number of alignments "+validAlignments);

//		System.out.println("Sorting merged alignments");
//		Collections.sort(alns,new GenomicRegionComparator(transcriptome.getSequenceNames()));
//		System.out.println("Saving merged alignments");
//		PrintStream out = new PrintStream(outFile);
//		merger.printHeader(file2,out);
//		alnsHandlerTranscriptome.saveReadAlignments(alns, out);
		outputFileStream.close();
	}
	/**
	 * Prints headers for the output file
	 * @param filename SAM file to get the SQ headers
	 * @param out Stream where headers will be printed
	 * @throws IOException If the file can not be read
	 */
	public void printHeader(String filename, PrintStream out) throws IOException {
		out.println("@HD\tVN:1.0\tSO:coordinate");
		SAMReadAlignmentsHandler.copySequenceHeaders(filename, out);
		out.println("@PG\tID:"+this.getClass().getName());
	}

        public long filterAlignments(FileInputStream inFile, PrintStream outFile) throws IOException{
       		BufferedReader SamReader = new BufferedReader(new InputStreamReader(inFile));
          	SAMReadAlignmentsHandler alnsHandler=new SAMReadAlignmentsHandler();

              	String line;
              line=SamReader.readLine();
              int i;
		for(i=0;line!=null;i++) {
//			System.out.println(line);
			ReadAlignment aln = alnsHandler.createReadAlignment(line);
			   if (aln == null) {
                            i--;
				line=SamReader.readLine();
                            continue;
                        }
                        if (aln.getSequenceName().compareTo("*") == 0) {
                            i--;
				line=SamReader.readLine();
                            continue;
                        }
                        if (validAlignment(aln)) {
                            validAlignments++;
                            alnsHandler.saveReadAlignment(aln, outFile);
                        }
                        line=SamReader.readLine();
               }
                outFile.flush();
                return i;

        }

        public boolean validAlignment(ReadAlignment aln) {
            int readLength= aln.getRead().length();
            String cigar = aln.getCigar();
            int softClippedBasesCount=0;
   	    int i = 0;
	    int n = cigar.length();
            do {
			int k = i;
			while (i < n && Character.isDigit(cigar.charAt(i))) {
				++i;
			}
			if (i == n) {
				throw new IllegalArgumentException(
						"Malformed CIGAR string: " + cigar);
			}
//	                System.out.println("k = "+k);
//	                System.out.println("i - 1 = "+(i-1));
			int elemLen = Integer.parseInt(cigar.substring(k,i), 10);
//	                System.out.println("elemLen = "+elemLen);
			char cigarCode = cigar.charAt(i);
			if (cigarCode == 'S')
                                softClippedBasesCount+=elemLen;
			++i;
		} while (i < n);
		
		//System.out.println("readLength "+readLength );
		//System.out.println("softClippedBasesCount"+softClippedBasesCount);

		System.out.println((readLength - softClippedBasesCount) );

		//System.out.println("division "+((double)softClippedBasesCount/(double)readLength) );


            if ((readLength - softClippedBasesCount) < mappableBasesThreshold || ((double)softClippedBasesCount)/(double)readLength > clippingThreshold) {
		  //System.out.println("false" );
                return false;
	     }
            else {
		  //System.out.println("true" );
                return true;

	    }

        }

}


