/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package edu.uconn.ngstools.main;
import edu.uconn.ngstools.Utils.Utils;
import edu.uconn.ngstools.readalignments.CommonSpanningAlignmentComparator;
import edu.uconn.ngstools.readalignments.Read;
import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.util.List;

import edu.uconn.ngstools.readalignments.ReadAlignment;
import edu.uconn.ngstools.readalignments.filehandlers.SAMReadAlignmentsHandler;
import java.util.ArrayList;

/**
 *
 * @author Sahar
 */
public class FilterMultipleAlignments {
private static PrintStream outputFileStream;
private static PrintStream filterAlignemntoutputFileStream;
private static FileInputStream inputFile;
private int mappableBasesThreshold = 15;
private static double clippingThreshold = 0.999;
private static int validAlignments = 0;
private static int DELETION_LENGTH_THREAHOLD = 15;
private static int INTRON_LENGTH_THRESHOLD = 500000;

public static void main(String[] args) throws Exception {
		FilterMultipleAlignments filter = new FilterMultipleAlignments();
		SAMReadAlignmentsHandler alnsHandler=new SAMReadAlignmentsHandler();
		alnsHandler.setMultipleAlnsPerRead(true);
                if (args.length < 3) {
                    System.err.println("Usage: filter-multiple-alns input_sam_file output_sam_file filtered_alignment_output_sam_file");
                    return;
                }
		int i=0;
		while(i<args.length && args[i].charAt(0)=='-') {
			if("-t".equalsIgnoreCase(args[i])) {
				i++;
				filter.mappableBasesThreshold = Integer.parseInt(args[i]);
			}
			i++;
		}
		String inFile = args[i];
		i++;
		String outFile = args[i];
                i++;
                String filteredOutFile = args[i];
                inputFile = new FileInputStream(inFile);
                outputFileStream = new PrintStream(outFile);
                filterAlignemntoutputFileStream=new PrintStream(filteredOutFile);
                System.out.println("Reading Alignments in SAM File");
                filter.printHeader(inFile,outputFileStream);
                //filter.printHeader(inFile,filterAlignemntoutputFileStream);
                long inputAlignmentsCount = filter.filterAlignments(inputFile,outputFileStream,filterAlignemntoutputFileStream);
    		//List<ReadAlignment> alns =
		System.out.println("Filtering process finished.");
//                System.out.println("Input number of alignments: "+inputAlignmentsCount);
 //               System.out.println("Filtered number of alignments "+validAlignments);

//		System.out.println("Sorting merged alignments");
//		Collections.sort(alns,new GenomicRegionComparator(transcriptome.getSequenceNames()));
//		System.out.println("Saving merged alignments");
//		PrintStream out = new PrintStream(outFile);
//		merger.printHeader(file2,out);
//		alnsHandlerTranscriptome.saveReadAlignments(alns, out);
		outputFileStream.close();
                inputFile.close();
	}
        public long filterAlignments(FileInputStream inFile, PrintStream outFile, PrintStream filterAlignemntoutputFileStream) throws IOException{

                BufferedReader SamReader = new BufferedReader(new InputStreamReader(inFile));
          	SAMReadAlignmentsHandler alnsHandler=new SAMReadAlignmentsHandler();
		List<ReadAlignment> readAlns = new ArrayList<ReadAlignment>();


                ReadAlignment aln = alnsHandler.createReadAlignment(SamReader);

		for(int i=0;aln!=null;i++) {
			if(readAlns.size()>0 && (readAlns.get(0).getRead().getId().compareTo(aln.getRead().getId()) != 0)) {
//			if(readAlns.size()>0 && !readAlns.get(0).getRead().getId().equals(aln.getRead().getId())) {
                            ParseAlns(readAlns,outFile,alnsHandler,filterAlignemntoutputFileStream);
				readAlns.clear();
                            if (aln.validAlignment(mappableBasesThreshold, clippingThreshold))
                                    readAlns.add(aln);
                            else
                                alnsHandler.saveReadFromAlignment(aln, filterAlignemntoutputFileStream);
			} else {
                                if (aln.validAlignment(mappableBasesThreshold, clippingThreshold))
                                    readAlns.add(aln);
                               else
                                    alnsHandler.saveReadFromAlignment(aln, filterAlignemntoutputFileStream);
			}
			aln = alnsHandler.createReadAlignment(SamReader);
		}
              if (readAlns.size()>0)
			ParseAlns(readAlns,outFile,alnsHandler,filterAlignemntoutputFileStream);
		return 0;
	}

        private void ParseAlns(List<ReadAlignment> readAlns, PrintStream outFile, SAMReadAlignmentsHandler alnsHandler, PrintStream filterAlignemntoutputFileStream) {
		CommonSpanningAlignmentComparator alnComp = new CommonSpanningAlignmentComparator();

            List<ReadAlignment> Alns = null;
            int readLength = readAlns.get(0).getRead().getQualityScores().length();
            List<Integer> gLocations = new ArrayList<Integer>(readLength);   
            List<Character> bStatus = new ArrayList<Character>(readLength);
            List<Character> cigar = new ArrayList<Character>(readLength);
            List<Character> strand = new ArrayList<Character>(readLength);
            List<String> Chr = new ArrayList<String>(readLength);
            Character currentStrand;


            Read forwardRead =  null;
            Read rcRead = null;

//	     System.out.println("in ParseAlns number of alns in list = "+readAlns.size());	
            Utils.InitArrayList(gLocations,-1,readLength);
            Utils.InitArrayList(bStatus,'a',readLength);
            Utils.InitArrayList(cigar,'!',readLength);
            Utils.InitArrayList(Chr,"X",readLength);
            Utils.InitArrayList(strand,'X',readLength);

  	    for(ReadAlignment aln: readAlns) {
               if ((aln.getFlags() & 0x10) != 0) { // reverse complemented
                    rcRead = aln.getRead();
                    currentStrand = '-';
              }
              else {
                    forwardRead = aln.getRead();
                    currentStrand = '+';
                }
                int prev_glocation = -1;
                for (int i = 0; i < readLength; i++){
                    if (aln.getCigarElem(i) == 'S')
                         //bStatus.set(i,'a');
			    continue;
                    else {
                        int g;
                        if(aln.getCigarElem(i) == 'I')
                             g = prev_glocation; // will be -1 if not preceeded by any M's
                        else
                             g = aln.getSequencePosition(i);
                        prev_glocation = g;
                        //stored is -1 if 'I' and not preceeded by 'M's (ambiguous
                        if ((gLocations.get(i) == -1) && (g != -1)) { 
//		              System.out.println("i location"+(i+1)+" "+g);
                            gLocations.set(i, g);
                            bStatus.set(i, 'u');
                            Chr.set(i, aln.getSequenceName());
                            cigar.set(i, aln.getCigarElem(i));
                            strand.set(i, currentStrand);
                        }
                       else if ((gLocations.get(i) != g) || (cigar.get(i) != aln.getCigarElem(i)) ||
                                (aln.getSequenceName().compareTo(Chr.get(i)) != 0) || currentStrand != strand.get(i)) {
                            bStatus.set(i,'a');
//		              System.out.println("ambiguous i location"+(i+1)+" "+g);
                            for (int j = i - 1; (j >= 0) && (cigar.get(j) == 'I'); j--) {
                                bStatus.set(j,'a');
// 				    System.out.println("ambiguous j location"+(j+1));

				}
			   } 
//			    else System.out.println("unambiguous noo change i location saved_location "+(i+1)+" "+g+" "+gLocations.get(i));


                    }
                }
            }
            // second pass: check number of unambigously mapped bases in each alignment
            // drop bases in alignment if < threshold
  	    for(ReadAlignment aln: readAlns) {
                List<Integer> mapped_positions = new ArrayList();
                for (int i = 0; i < readLength; i++){
                    if (aln.getSequencePosition(i) == gLocations.get(i) && bStatus.get(i) == 'u')
                        mapped_positions.add(i);
                }
                if (mapped_positions.size() < mappableBasesThreshold)
                    for (int i = 0; i < mapped_positions.size() ; i++) {
                        bStatus.set(mapped_positions.get(i),'a');
// 	                 System.out.println("ambiguous i location"+(mapped_positions.get(i)+1));
                        for (int j = mapped_positions.get(i) - 1; j >= 0 && cigar.get(j) == 'I'; j--) {
                            bStatus.set(j,'a');
//   			       System.out.println("ambiguous j location"+(j+1));
			   }
                    }
            }
            boolean secondRead;
            if ((readAlns.get(0).getFlags() & 0x80) != 0)
                secondRead = true;
            else
                secondRead = false;
            Alns = createAlns(gLocations,bStatus,cigar,Chr,strand,forwardRead,rcRead,secondRead);

            if (Alns != null)
                alnsHandler.saveReadAlignments(Alns, outFile);
            else
                alnsHandler.saveReadFromAlignment(readAlns.get(0), filterAlignemntoutputFileStream);

        }

     /**
     * generate local alignments for all stretches of non-ambiguous bases of read.
      * These alignments are based on the (unique) genomic locations saved for each
      * non-ambiguous base mapped to a certain strand. Method fails if  there are too few
      * non-ambiguous bases, or if locations for different bases are in different
      * chromosomes or are not monotonically increasing/decreasing along the read
     * @return true list of created local alignments if successful and null otherwise
     */
        private  List<ReadAlignment> createAlns(List<Integer> gLocations, List<Character> bStatus,
                  List<Character> cigarElements, List<String> Chr, List<Character> strands, Read forwardRead, Read rcRead,
                  boolean secondRead) {

            List<ReadAlignment> alns = new ArrayList<ReadAlignment>();
            int startPosition;
            StringBuilder cigar = new StringBuilder();
            int direction;
            short flag = 0;
            Read read;

//	     System.out.println("in createAlns reverseCompl = "+reverseCompl+" read ID = "+read.getId());
            direction = validAlignmentAndDirection(gLocations,bStatus,cigarElements,Chr,strands);
            if (direction == 0)
                    return null;

//	     System.out.println("in createAlns after direction ");	

            int i = 0;
            while ( i < bStatus.size() && bStatus.get(i) == 'a')
                i++;   

            if (i == bStatus.size())
                return null;

//	     System.out.println("in createAlns after a's ");	


            int prev_gloc; // = gLocations.get(i);
            Character prevCigarElem; // = cigarElements.get(i);
            int cigarElemLength; // = 1;
            //boolean firstMappedBase = true;

            while (i < bStatus.size()){
// 	         System.out.println("outer loop i = "+i+"status = "+bStatus.get(i)+"cigar = "+ cigarElements.get(i));	
                startPosition = gLocations.get(i);
		  if (i > 0) {
//		     	  System.out.println("appending S i = "+i);	
	                cigar.append(Integer.toString(i));
           	         cigar.append('S');
	         }
//		  System.out.println("strand "+strands.get(i));
                if (strands.get(i) == '-') {
                    flag = 0x10;
//		      System.out.println("flag "+flag);
                    read = rcRead;
                }
                else
                    read = forwardRead;
                prevCigarElem = cigarElements.get(i);
                prev_gloc = gLocations.get(i);
                cigarElemLength = 1;
                i++;
                while (i < bStatus.size() && bStatus.get(i) == 'u')
                {

//		      System.out.println("i = "+i+"status = "+bStatus.get(i)+"cigar = "+ cigarElements.get(i));	
                    if (cigarElements.get(i) == 'I') {
                       cigar.append(cigarElemLength);
                       cigar.append(prevCigarElem);
                       cigarElemLength = 0;
                        while (i < bStatus.size() && bStatus.get(i) == 'u' && cigarElements.get(i) == 'I') {
                            cigarElemLength++;
                            i++;
                        }
                        cigar.append(cigarElemLength);
                        cigar.append('I');
                        // pase one position ahead
                        if (i < bStatus.size() && bStatus.get(i) == 'u') {
                            prevCigarElem = cigarElements.get(i);
                            prev_gloc = gLocations.get(i);
                            cigarElemLength = 1;
                            i++;
                        }
                        else
                            break;   //  no more positions to parse; should not happen coz 'I' does not come at the end
                    }
                    if (i == bStatus.size() || bStatus.get(i) == 'a')
                        break;
//			 System.out.println("loc prev_loc"+gLocations.get(i)+" "+prev_gloc);
                    int gap = ((gLocations.get(i) - prev_gloc)* direction) - 1;
                    if (gap == 0) {//consecutive
                         if (prevCigarElem == cigarElements.get(i))  //same cigar
                             cigarElemLength++;
                         else {
                            cigar.append(cigarElemLength);
                            cigar.append(prevCigarElem);
                            cigarElemLength = 1;
                         }
                    }
                    else if (gap > INTRON_LENGTH_THRESHOLD)
                            break;
                         else  { //non-consecutive (need N or D element)
                        cigar.append(cigarElemLength);
                        cigar.append(prevCigarElem);
                        cigarElemLength = 1;
                        cigar.append(gap);
                        if (gap <= DELETION_LENGTH_THREAHOLD) {
                            cigar.append('D');
                        }
                        else {
                            cigar.append('N');
                        }
                     }
                     prev_gloc = gLocations.get(i);
                     prevCigarElem = cigarElements.get(i);
                     i++;
                }  // status = 'u'
                if (secondRead)
                    read.setId(read.getId()+"_2");
                cigar.append(cigarElemLength);
                cigar.append(prevCigarElem);
                cigarElemLength = read.length() - i;
		  if (cigarElemLength > 0) {
//		     	  System.out.println("appending S cigarElemLEngth = "+cigarElemLength );	


	                cigar.append(cigarElemLength);
       	         cigar.append('S');
		  }
	//	  if (i <= 0)
//	     System.out.println("i = "+i+" read ID = "+read.getId()+" startPosition"+startPosition+"cigar "+cigar.toString());
//	     	  System.out.println("Chr,startPosition,cigar "+Chr.get(i-1)+" "+startPosition+" "+cigar.toString());	
                ReadAlignment aln = null;;
                try {
                    aln = new ReadAlignment(read,Chr.get(i-1),startPosition,cigar.toString(),(short)255);
		} catch (Exception e) {
        		System.err.println("Exception creating alignment for read "+read.getId()+" at position "+Chr.get(i-1)+startPosition+" and CIGAR "+cigar.toString());
			e.printStackTrace();

                }
                if (aln == null)
                    continue;
                aln.setFlags(flag);
                aln.setInsertSize(0);
                aln.setMateSequenceName("*");
                aln.setMatePosition(0);
                alns.add(aln);
                cigar.delete(0, cigar.length());
                while ( i < bStatus.size() && bStatus.get(i) == 'a')
                    i++;
                //firstMappedBase = true;
            }

            if (alns.isEmpty()) {
//	     	  System.out.println("in createAlns alns is empty on return");	
                return null;
	     }
            else {
//	     	  System.out.println("in createAlns alns is not empty on return");	
                return alns;
	     }
    }

    /**
      * Computes the validity of uniquely aligned bases of a read according to the number
      * non-ambiguous bases, if locations for different bases are in different
      * chromosomes, and whether the genomic positions of the aligned bases are
     *  not monotonically increasing/decreasing along the read
     *  @return 1 if the genomic positions of the aligned bases are
     *  not monotonically increasing, -1 if decreasing, 0 if the aligned bases are considered invalid.
    */
        private int validAlignmentAndDirection(List<Integer> gLocations, List<Character> bStatus, List<Character> cigar, List<String> Chr, List<Character> strands) {

            int i = 0;
            int indexOfFirstMappedBase = 0;
            int firstLocation = 0;
            int secondLocation = 0;
            int direction;


            while (i < bStatus.size() && bStatus.get(i) == 'a') {
                i++;
            }
            if (i < bStatus.size()) {
                firstLocation = gLocations.get(i);
                secondLocation = firstLocation;
                indexOfFirstMappedBase = i;
		  i++;
            }
            while (i < bStatus.size() && bStatus.get(i) == 'a') {
                i++;
            }
            if (i < bStatus.size()) {
                secondLocation = gLocations.get(i);
            }

            if (firstLocation > secondLocation)
                direction = -1;
            else if (firstLocation < secondLocation)
                direction = 1;
            else // 2 bases mapped to the same location; or only one base mapped
                return 0; //invalid alignment

            String firstChr = Chr.get(indexOfFirstMappedBase);
            Character firstStrand = strands.get(indexOfFirstMappedBase);
            int unambiguousBases = 1;
            int prev_location = firstLocation;

            for (i = indexOfFirstMappedBase + 1; i < bStatus.size(); i++) {
//		  System.out.println("status location "+bStatus.get(i)+" "+gLocations.get(i));
                if (bStatus.get(i) == 'u') {
                    // locations for different bases are on the same chromosome, same strand and monotonically
                    // increasing/decreasing along the read
                    if (((gLocations.get(i) - prev_location) * direction) > 0 && 
                            Chr.get(i).compareTo(firstChr) == 0 && strands.get(i) == firstStrand)
                        unambiguousBases++;
                    else // invalid
                        return 0;
                }
            }

            if (unambiguousBases >= mappableBasesThreshold)
                return direction;
            else //invalid
                return 0;
        }
        public boolean multipleLocalAlns(ReadAlignment aln1, ReadAlignment aln2) {

                boolean retVal;

                if(aln1.getSequenceName().compareTo(aln2.getSequenceName()) != 0) { // not mapped to the same chromosome.. multiple
//		      System.out.println("multiple.. chr not equal");
                    return true;
                }

                int indexOfFirstAlignedBase1 = aln1.getIndexOfFirstAlignedBase();
                int indexOfLastAlignedBase1 = aln1.getIndexOfLastAlignedBase();
                int indexOfFirstAlignedBase2 = aln2.getIndexOfFirstAlignedBase();
                int indexOfLastAlignedBase2 = aln2.getIndexOfLastAlignedBase();
                int intersectionStart = Math.max(indexOfFirstAlignedBase1,indexOfFirstAlignedBase2);
                int intersectionEnd = Math.min(indexOfLastAlignedBase1, indexOfLastAlignedBase2);

                if ((intersectionStart < intersectionEnd) && (aln1.getSequencePosition(intersectionStart) != aln2.getSequencePosition(intersectionStart))) {
                    if (intersectionStart > indexOfFirstAlignedBase1)
                        aln1.clipAlignment(indexOfFirstAlignedBase1,intersectionStart);
                    if (intersectionEnd < indexOfLastAlignedBase1)
                        aln1.clipAlignment(intersectionEnd,indexOfLastAlignedBase1);
                    if (intersectionStart > indexOfFirstAlignedBase2)
                        aln2.clipAlignment(indexOfFirstAlignedBase2,intersectionStart);
                    if (intersectionEnd < indexOfLastAlignedBase2)
                        aln2.clipAlignment(intersectionEnd,indexOfLastAlignedBase2);
                    if (aln1.validAlignment(mappableBasesThreshold, clippingThreshold) && aln2.validAlignment(mappableBasesThreshold, clippingThreshold)) {
	  	          System.out.println("unique.. OK after clipping");
                        retVal = false;
			}	
                    else  {   //after clipping intersection one of the alignments is not valid (too short)
   	  	          System.out.println("multiple.. too short after clipping");
                        retVal = true;
			}

                }
                else{ // no intersection or intersection map to the same genomic position
    	             System.out.println("unique.. no intersection or map to the same location");
                    retVal = false;
		}

                return retVal;
        }

	/**
	 * Prints headers for the output file
	 * @param filename SAM file to get the SQ headers
	 * @param out Stream where headers will be printed
	 * @throws IOException If the file can not be read
	 */

	public void printHeader(String filename, PrintStream out) throws IOException {
		out.println("@HD\tVN:1.0\tSO:coordinate");
		SAMReadAlignmentsHandler.copySequenceHeaders(filename, out);
		out.println("@PG\tID:"+this.getClass().getName());
	}

}
