/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package edu.uconn.ngstools.main;

import edu.uconn.ngstools.variants.CalledSNV;
import edu.uconn.ngstools.variants.filehandlers.CalledSNVSFileHandler;
import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.io.PrintStream;

/**
 *
 * @author Sahar
 */
public class PhaseIsolatedSNVs {

private static PrintStream outputPhasedSNVFileStream;
private static FileInputStream inSNVFile;
private static FileInputStream inPhaseFile;
private static String separator = "\t";

    public static void main(String[] args) throws Exception {
	String inSNVFileName = args[0];
        String inPhaseFileName = args[1];
	String outFileName = args[2];
        inSNVFile = new FileInputStream(inSNVFileName);
        inPhaseFile = new FileInputStream(inPhaseFileName);
        outputPhasedSNVFileStream = new PrintStream(outFileName);
        CalledSNVSFileHandler SNVHandler = new CalledSNVSFileHandler();

	BufferedReader inSNV = new BufferedReader(new InputStreamReader(inSNVFile));
	BufferedReader inPhasedSNV = new BufferedReader(new InputStreamReader(inPhaseFile));
	String Phasedline=inPhasedSNV.readLine();
        int block = 0;
        int prevBlockInFile = 0;
      	String SNVLine=inSNV.readLine();
        CalledSNV snv;
        String snvSeqname="";
        int snvPos = 0;
	for(int i=0;Phasedline!=null;i++) {
		String [] items = Phasedline.split("\t");
		String seqName = items[0];
		int absPos = Integer.parseInt(items[1]);
		char a1 = items[2].charAt(0);
                char a2 = items[3].charAt(0);
		int currentBlockInFile = Integer.parseInt(items[4]);

                while (SNVLine != null &&  snvSeqname.compareTo(seqName) != 0 && snvPos != absPos)  {
                    if (snvSeqname.compareTo("") != 0) {
                        block++;
                        writePhasedSNV(snvSeqname,snvPos,'0','1',block);
                    }
                    SNVLine=inSNV.readLine();
                    if (SNVLine != null) {
                        snv = SNVHandler.loadCalledSNV(SNVLine);
                        snvSeqname = snv.getSequenceName();
                        snvPos = snv.getPosition();
                    }
                }
                if (currentBlockInFile != prevBlockInFile)
                    block++;
                writePhasedSNV(seqName,absPos,a1,a2,block);
                Phasedline=inPhasedSNV.readLine();

	}
        while (SNVLine != null)  {
            block++;
            writePhasedSNV(snvSeqname,snvPos,'0','1',block);
            SNVLine=inSNV.readLine();
            if (SNVLine != null) {
                snv = SNVHandler.loadCalledSNV(SNVLine);
                snvSeqname = snv.getSequenceName();
                snvPos = snv.getPosition();
            }
        }
	inSNVFile.close();
        inPhaseFile.close();
        outputPhasedSNVFileStream.close();


    }
    private static void writePhasedSNV(String Seqname, int snvPos,char a1, char a2,int block) {
        outputPhasedSNVFileStream.print(Seqname);
	outputPhasedSNVFileStream.print(separator);
        outputPhasedSNVFileStream.print(snvPos);
	outputPhasedSNVFileStream.print(separator);
        outputPhasedSNVFileStream.print(a1);
	outputPhasedSNVFileStream.print(separator);
        outputPhasedSNVFileStream.print(a2);
	outputPhasedSNVFileStream.print(separator);
        outputPhasedSNVFileStream.println(block);

    }

    }

