/*******************************************************************************
 * NGSTools - Java tools for analysis of Next Generation Sequencing (NGS) data
 * Copyright 2010 Jorge Duitama
 *
 * This file is part of NGSTools.
 *
 *     NGSTools is free software: you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation, either version 3 of the License, or
 *     (at your option) any later version.
 *
 *     NGSTools is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License
 *     along with NGSTools.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package edu.uconn.ngstools.readalignments;

import java.util.Comparator;
/**
 * Comparator for raw reads based on the read id
 * @author Jorge Duitama
 */
public class ReadIdComparator implements Comparator<Read> {

	@Override
	public int compare(Read o1, Read o2) {
		if(o1.getId()==null) {
			if(o2.getId()==null) {
				return 0;
			}
			return 1;
		}
		if(o2.getId()==null) {
			return -1;
		}
		return o1.getId().compareTo(o2.getId());
	}

}
