/*******************************************************************************
 * NGSTools - Java tools for analysis of Next Generation Sequencing (NGS) data
 * Copyright 2010 Jorge Duitama
 *
 * This file is part of NGSTools.
 *
 *     NGSTools is free software: you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation, either version 3 of the License, or
 *     (at your option) any later version.
 *
 *     NGSTools is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License
 *     along with NGSTools.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package edu.uconn.ngstools.sequences;

import java.util.ArrayList;
import java.util.List;
/**
 * Stores sorted default sequence names for genome analysis consistent with the UCSC reference
 * genomes
 * @author Jorge Duitama
 *
 */
public class DefaultSequenceNames {
	/**
	 * Sorted list of sequence names as chr1, chr2, ... , chr22, chrX, chrY, chrM
	 */
	public static final List<String> DEFAULT_SEQUENCE_NAMES = loadDefaultSequenceNames();

	private static List<String> loadDefaultSequenceNames() {
		List<String> seqNames = new ArrayList<String>();
		for(int i=1;i<=22;i++) {
			seqNames.add("chr"+i);
		}
		seqNames.add("chrX");
		seqNames.add("chrY");
		seqNames.add("chrM");
		return seqNames;
	}
	
}
