/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package edu.uconn.ngstools.variants;

/**
 *
 * @author Sahar
 */
public class ClassifiedSNV extends CalledSNV{



    public static final String NonStop="NonStop";
    public static final String Nonsense="Nonsense";
    public static final String Missense="Missense";
    public static final String Undefined="-";

    private boolean nonSynonymous;   //always false if SNV is homozygous or triallelic and flag is not set to call epitopes in these cases
    private String type; //if nonSynonymous==true (NonStop/Nonsense/Missense) else undefined


    public ClassifiedSNV(String sequenceName, int position, char refBase, char altBase, String genotype) {
        super(sequenceName, position, refBase, altBase, genotype);
        nonSynonymous = false;   //always false if SNV is heterozygous or triallelic and flag is not set to call epitopes in these cases
        type = Undefined;
    }

    public boolean moreInterstingCategory(ClassifiedSNV snv) {
        boolean ret_val=false;
        if (type.equals(NonStop) && !snv.getType().equals(NonStop))
            ret_val=true;
        else if (type.equals(Nonsense) && (snv.getType().equals(Missense) || !snv.isNonSynonymous()))
                 ret_val = true;
        else if (type.equals(Missense) &&  !snv.isNonSynonymous())
                ret_val = true;
        return ret_val;
    }
    public void setNonSynonymous(boolean nonSynonymous) {
        this.nonSynonymous = nonSynonymous;
    }

    public boolean isNonSynonymous() {
        return nonSynonymous;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }



}
