/*******************************************************************************
 * NGSTools - Java tools for analysis of Next Generation Sequencing (NGS) data
 * Copyright 2010 Jorge Duitama
 *
 * This file is part of NGSTools.
 *
 *     NGSTools is free software: you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation, either version 3 of the License, or
 *     (at your option) any later version.
 *
 *     NGSTools is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License
 *     along with NGSTools.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package edu.uconn.ngstools.variants.filehandlers;

import java.io.IOException;
import java.util.List;

import edu.uconn.ngstools.variants.SNV;

/**
 * Common interface for classes that handle i/o operations for SNVs
 * @author Jorge Duitama
 */
public interface SNVSFileHandler {
	/**
	 * Loads SNVs from the given file
	 * @param snvsFilename Name of the file to load the SNVs from 
	 * @return List<SNV> List of SNVs in the given file
	 * @throws IOException If the file can not be read
	 */
	public List<SNV> loadSNVS(String snvsFilename) throws IOException;
}
