package edu.uconn.bioinformatics.epitopeFinder;


public class EpitopeHit {
	public static final int MIN_EPITOPE_LENGTH=8;
	public static final int MAX_EPITOPE_LENGTH=15;
	private String motif;
	private String epitope;
	private int position=0;
	private double score=0;
	private String referenceEpitope;
	private double referenceScore=0;
        private boolean added;
	public EpitopeHit(String motif, String epitope, int position ,  double score) {
		super();
		assert position >=0;
		assert epitope.length() >= MIN_EPITOPE_LENGTH;
		this.motif = motif;
		this.epitope = epitope;
		this.position = position;
		this.score = score;
                this.added=false;
	}

        public boolean isAdded() {
            return added;
        }

        public void setAdded(boolean added) {
            this.added = added;
        }


	public String getMotif() {
		return motif;
	}
	public void setMotif(String motif) {
		this.motif = motif;
	}
	public String getEpitope() {
		return epitope;
	}
	public void setEpitope(String epitope) {
		this.epitope = epitope;
	}
	public int getPosition() {
		return position;
	}
	public void setPosition(int position) {
		this.position = position;
	}
	public double getScore() {
		return score;
	}
	public void setScore(double score) {
		this.score = score;
	}
	
	public String getReferenceEpitope() {
		return referenceEpitope;
	}
	public void setReferenceEpitope(String referenceEpitope) {
		this.referenceEpitope = referenceEpitope;
	}
	public double getReferenceScore() {
		return referenceScore;
	}
	public void setReferenceScore(double referenceScore) {
		this.referenceScore = referenceScore;
	}
	
}
