package edu.uconn.bioinformatics.epitopeFinder;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintStream;

public class NetMHCHandler { 
	public void generateProteinFasta(String reportFilename, PrintStream out) throws IOException {
		String separator = "\t";
		FileInputStream fis = new FileInputStream(reportFilename);
		BufferedReader in = new BufferedReader(new InputStreamReader(fis));
		String line=in.readLine();
		for(int i=0;line!=null;i++) {
			String [] items = line.split(separator);
			if(items.length>6 && !"-".equals(items[4])) {
				out.println(">"+items[0]+"|"+items[1]+"|"+items[3]+"|ref");
				out.println(items[4]);
				if(!items[4].equals(items[6])) {
					out.println(">"+items[0]+"|"+items[1]+"|"+items[3]+"|alt");
					out.println(items[6]);
				}
			}
			line=in.readLine();
		}
		out.flush();
		in.close();
	}
	public static void main(String[] args) throws IOException {
		NetMHCHandler handler = new NetMHCHandler();
		handler.generateProteinFasta(args[0], System.out);
	}
}
