package edu.uconn.bioinformatics.epitopeFinder;

public class PredictionPWM {
	private String motif;
	private short [][] matrix;
	
	public PredictionPWM(String motif, short[][] matrix) {
		super();
		this.motif = motif;
		this.matrix = matrix;
	}
	
	public String getMotif() {
		return motif;
	}
	public int getLength() {
		return matrix[0].length;
	}
	
	public int calculateScore(String epitope) {
		assert epitope.length() == getLength();
		int score = 0;
		for (int j=0;j < epitope.length();j++) {
			char aminoacid = Character.toUpperCase(epitope.charAt(j));
			int i = aminoacid - 65;
			if(i>=0 && i<matrix.length) score+=matrix[i][j];
			//else System.err.println("WARN: Aminoacid not found for epitope: "+epitope);
		}
		return score;
	}
	
}
