package edu.uconn.bioinformatics.epitopeFinder;

import java.util.List;
import java.util.Map;
import java.util.Set;

public interface ProteinEpitopeChecker {
	public List<EpitopeHit> findEpitopes(String proteinSequence) throws Exception;
	public List<EpitopeHit> findEpitopes(String proteinSequence, double minScore) throws Exception;
	public Map<String,List<EpitopeHit>> findEpitopes(Set<String> proteinSequences, double minScore) throws Exception;
	public double getScore (String epitope, String motif) throws Exception;
	public void setMotifs (String motifs);
        public void setAlgorithm(String algorithm);
}
