package edu.uconn.bioinformatics.fileHandlers;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

import edu.uconn.ngstools.sequences.DNASequence;
import edu.uconn.ngstools.variants.CalledSNV;
import edu.uconn.ngstools.variants.SNV;
import edu.uconn.ngstools.variants.filehandlers.SNVSFileHandler;

public class MaqSNVSFileHandler implements SNVSFileHandler{
	@Override
	public List<SNV> loadSNVS(String maqSnvsFilename) throws IOException {
		List<SNV> snvs = new ArrayList<SNV>();
		FileInputStream fis = new FileInputStream(maqSnvsFilename);
		BufferedReader in = new BufferedReader(new InputStreamReader(fis));
		String line=in.readLine();
		while(line!=null) {
			String [] items = line.split(" |\t");
			char ref = items[2].charAt(0);
			char alt = items[3].charAt(0);
			String genotype = ""+alt+""+alt;
			if(!DNASequence.isInAlphabeth(alt)) {
				alt = items[9].charAt(0);
				genotype = ""+ref+""+alt;
			}
			if(!DNASequence.isInAlphabeth(alt)) {
				alt = items[11].charAt(0);
				genotype = ""+ref+""+alt;
			}
			
			SNV snv = new CalledSNV(items[0],Integer.parseInt(items[1]),ref,alt,genotype);
			snvs.add(snv);
			line=in.readLine();
		}
		fis.close();
		return snvs;
	}
	
}
