package edu.uconn.bioinformatics.programs;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.io.PrintStream;

import net.sf.picard.liftover.LiftOver;
import net.sf.picard.util.Interval;

public class BasicLiftover {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		String inputFile = args[0];
		String chainFile = args[1];
		PrintStream out = System.out;
		LiftOver liftOver = new LiftOver(new File(chainFile));
		FileInputStream fis = new FileInputStream(inputFile);
		BufferedReader in = new BufferedReader(new InputStreamReader(fis));
		String line = in.readLine();
		while(line!=null) {
			String [] items = line.split("\t");
			int pos = Integer.parseInt(items[1]);
			Interval interval = new Interval(items[0], pos, pos);
			Interval interval2 = liftOver.liftOver(interval);
			if(interval2!=null) {
				out.print(interval2.getSequence()+"\t"+interval2.getStart());
				for(int i=2;i<items.length;i++) {
					out.print("\t"+items[i]);
				}
				out.println();
			} else {
				System.err.println("Interval: "+interval+ " not translated");
			}
			line = in.readLine();
		}
		fis.close();
	}
}
