package edu.uconn.bioinformatics.programs;

import edu.uconn.ngstools.sequences.DNAMaskedSequence;
import edu.uconn.ngstools.sequences.Sequence;
import edu.uconn.ngstools.sequences.filehandlers.FastaSequencesHandler;


public class FastaSubsequencesExtractor {
	public static void main(String[] args) throws Exception {
		String referenceFilename = args[0];
		String seqName = args[1];
		int start = Integer.parseInt(args[2]);
		int end = Integer.parseInt(args[3]);
		int lineLength = Integer.parseInt(args[4]); 
		FastaSequencesHandler wholeReference = new FastaSequencesHandler();
		wholeReference.setSequenceType(DNAMaskedSequence.class);
		wholeReference.loadSequences(referenceFilename);
		FastaSequencesHandler selectedRegion = new FastaSequencesHandler();
		Sequence seq = wholeReference.getSequence(seqName);
		Sequence selectedSeq = new DNAMaskedSequence(seq.substring(start-1,end));
		selectedRegion.addSequence(seqName+"_"+start+"_"+end, selectedSeq);
		selectedRegion.saveSequences(System.out, lineLength);
	}
}
