package edu.uconn.bioinformatics.programs;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.io.PrintStream;

import net.sf.picard.liftover.LiftOver;
import net.sf.picard.util.Interval;

public class HapmapGenotypesLiftover {
	public static void main(String[] args) throws Exception {
		String inputFile = args[0];
		String chainFile = args[1];
		PrintStream out = System.out;
		LiftOver liftOver = new LiftOver(new File(chainFile));
		FileInputStream fis = new FileInputStream(inputFile);
		BufferedReader in = new BufferedReader(new InputStreamReader(fis));
		String line = in.readLine();
		out.println(line);
		line = in.readLine();
		while(line!=null) {
			String [] items = line.split(" ");
			int pos = Integer.parseInt(items[3]);
			Interval interval = new Interval(items[2], pos, pos);
			Interval interval2 = liftOver.liftOver(interval);
			if(interval2!=null && interval.getSequence().equals(interval2.getSequence())) {
				out.print(items[0]+" "+items[1]+" "+interval2.getSequence()+" "+interval2.getStart()+" + ncbiB37");
				for(int i=6;i<items.length;i++) {
					out.print(" "+items[i]);
				}
				out.println();
			} else {
				System.err.println("Interval: "+interval+ " not translated");
			}
			line = in.readLine();
		}
		fis.close();
	}
}
