package edu.uconn.bioinformatics.programs;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.List;
import java.util.Random;
import java.util.Set;
import java.util.TreeSet;

import edu.uconn.ngstools.readalignments.ReadAlignment;
import edu.uconn.ngstools.readalignments.filehandlers.SAMReadAlignmentsHandler;
import edu.uconn.ngstools.sequences.Sequence;
import edu.uconn.ngstools.sequences.filehandlers.FastaSequencesHandler;

public class RepeatedReadsFilter {
	public static void main(String[] args) throws Exception {
		SAMReadAlignmentsHandler samHandler = new SAMReadAlignmentsHandler();
		FastaSequencesHandler fastaHandler = new FastaSequencesHandler();
		fastaHandler.loadSequences(args[1]);
		List<String> g0 = new ArrayList<String>();
		List<String> g1 = new ArrayList<String>();
		List<String> g2 = new ArrayList<String>();
		Set<String> seqs = new TreeSet<String>(); 
		Random r = new Random();
		Sequence seq = null;
		String lastSeqName = null;
		int lastStart =0;
		FileInputStream fis = new FileInputStream(args[0]);
		PrintStream out = System.out;
		BufferedReader in = new BufferedReader(new InputStreamReader(fis));
		String line = in.readLine();
		while(line!=null) {
			if(line.startsWith("@")) {
				out.println(line);
			} else {
				ReadAlignment aln = samHandler.createReadAlignment(line);
				if(aln!=null) {
					if(!aln.getSequenceName().equals(lastSeqName) || aln.getStart()!=lastStart) {
						if(g0.size()>0) out.println(g0.get(r.nextInt(g0.size())));
						if(g1.size()>0) out.println(g1.get(r.nextInt(g1.size())));
						if(g2.size()>0) out.println(g2.get(r.nextInt(g2.size())));
						out.flush();
						g0.clear();
						g1.clear();
						g2.clear();
						seqs.clear();
						if(!aln.getSequenceName().equals(lastSeqName)) {
							seq = fastaHandler.getSequence(aln.getSequenceName());
							lastSeqName = aln.getSequenceName();
						}
						lastStart = aln.getStart();
					}
					
					String readSeq = aln.getRead().toString();
					if(!seqs.contains(readSeq)) {
						seqs.add(readSeq);
						int l = readSeq.length();
						int nMis = 0;
						for(int i=0;i<l;i++) {
							char c1 = Character.toUpperCase(readSeq.charAt(i));
							int seqPos = aln.getSequencePosition(i)-1;
							if(seqPos>=0) {
								if(Character.toUpperCase(seq.charAt(seqPos)) != c1) {
									nMis++;
								}
							}
						}
						if(nMis == 0) {
							g0.add(line);
						} else if (nMis == 1) {
							g1.add(line);
						} else {
							g2.add(line);
						}
					}
				}
			}
			line = in.readLine();
		}
		in.close();
	}
}
