package edu.uconn.bioinformatics.programs;

import java.util.List;

import edu.uconn.ngstools.genome.GenomicRegionComparator;
import edu.uconn.ngstools.sequences.DefaultSequenceNames;
import edu.uconn.ngstools.variants.CalledSNV;
import edu.uconn.ngstools.variants.filehandlers.CalledSNVSFileHandler;

public class SNPSIntersect {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		GenomicRegionComparator cmp = new GenomicRegionComparator(DefaultSequenceNames.DEFAULT_SEQUENCE_NAMES);
		CalledSNVSFileHandler snvsHandler = new CalledSNVSFileHandler();
		List<CalledSNV> snvs1 = snvsHandler.loadCalledSNVS(args[0]);
		List<CalledSNV> snvs2 = snvsHandler.loadCalledSNVS(args[1]);
		int i=0;
		int j=0;
		while(i<snvs1.size() && j<snvs2.size()) {
			CalledSNV s1 = snvs1.get(i);
			CalledSNV s2 = snvs2.get(j);
			int x = cmp.compare(s1,s2);
			if(x==0) {
				snvsHandler.saveSNV(s1, System.out,false);
				i++;
				j++;
			} else if (x<0) {
				i++;
			} else {
				j++;
			}
		}
	}

}
